#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include "make_path.h"

static char s_flag;
static char f_flag;
static char v_flag;

static int ln(const char *src, const char *dst) {
	if (f_flag)
		if (unlink(dst) && v_flag)
			fprintf(stderr, "ln: removed %s\n", dst);

	int ret = 0;
	if (s_flag)
		ret = symlink(src, dst);

	else
		ret = link(src, dst);

	if (!ret && v_flag)
		fprintf(stderr, "ln: linked %s to %s\n", src, dst);

	return ret;
}

int main(int argc, char **argv) {
	int opt;
	while ((opt = getopt(argc, argv, "sfv")) != -1) {
		switch (opt) {
			case 's':
				s_flag = 1;
				break;

			case 'f':
				f_flag = 1;
				break;

			case 'v':
				v_flag = 1;
				break;

			default:
				puts("ln [sfv] [src] [dst]\n\t-f Force\n\t-s Symbolic\n\t-v Verbose");
				return 0;
		}
	}

	argv += optind;
	argc -= optind;

	if (argc == 2) {
		if (ln(argv[0], argv[1])) {
			char *new_path = mu_make_path("ln", argv[1], argv[0]);
			if (new_path == NULL)
				return 1;

			if (ln(argv[0], new_path)) {
				free(new_path);
				fprintf(stderr, "ln: %s %s\n", argv[1], strerror(errno));
				return 1;
			}

			free(new_path);
		}
	}

	else {
		fprintf(stderr, "ln: missing operand\n");
		return 1;
	}

	return 0;
}
